/*
===============================================================================

	FILE:	codec.h
	
	CONTENTS:
	
		Face Fixer - SIGGRAPH 2000 demonstration software
	
	PROGRAMMERS:
	
		Martin Isenburg@cs.unc.edu
	
	COPYRIGHT:
	
		Copyright (C) 2000  Martin Isenburg (isenburg@cs.unc.edu)
		
		This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
	CHANGE HISTORY:
	
		28 April 2000 -- Martin - finalized for SIGGRAPH submission.
	
===============================================================================
*/
#ifndef FF_CODEC_H
#define FF_CODEC_H

class FFlabel;
class FFvector;
class FFtwinEdge;

class FFcodec
{
public:
  FFvector* ls;
  FFvector* gs;

  int r;
  int l;
  int s;
  int e;
  int h;
  int m;
  int f[7];
  int large_f;
  
  void pushLabelR();
  void pushLabelL();
  void pushLabelS();
  void pushLabelE();

  void pushLabelF(int d);
  void pushLabelH(int d);

  void pushLabelM(int i, int o1, int o2);

  void pushGate(FFtwinEdge* g);
  
  FFlabel* popLabel();

  FFtwinEdge* popGate();
  
  int hasMoreGates();
  
  FFcodec();
  ~FFcodec();
};

#endif
