/*
===============================================================================

	FILE:	label.h
	
	CONTENTS:
	
		Face Fixer - SIGGRAPH 2000 demonstration software
	
	PROGRAMMERS:
	
		Martin Isenburg@cs.unc.edu
	
	COPYRIGHT:
	
		Copyright (C) 2000  Martin Isenburg (isenburg@cs.unc.edu)
		
		This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
	CHANGE HISTORY:
	
		28 April 2000 -- Martin - finalized for SIGGRAPH submission.
	
===============================================================================
*/
#ifndef FF_LABEL_H
#define FF_LABEL_H

class FFlabel
{
public:
  enum Type { F, H, R, L, S, E, M };

  Type type;
  int data1;
  int data2;
  int data3;

  int getDegree(); // for label F and H

  int getIndex();  // for label M
  int getOffset1();
  int getOffset2();
  
  FFlabel();
  FFlabel(Type t);                        // for label R, L, S, and E
  FFlabel(Type t, int d);                 // for label F and H
  FFlabel(Type t, int i, int o1, int o2); // for label M

  ~FFlabel();
};

#endif
