/*
===============================================================================

	FILE:	mesh.h
	
	CONTENTS:
	
		Face Fixer - SIGGRAPH 2000 demonstration software
	
	PROGRAMMERS:
	
		Martin Isenburg@cs.unc.edu
	
	COPYRIGHT:
	
		Copyright (C) 2000  Martin Isenburg (isenburg@cs.unc.edu)
		
		This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
	CHANGE HISTORY:
	
		28 April 2000 -- Martin - finalized for SIGGRAPH submission.
	
===============================================================================
*/
#ifndef FF_MESH_H
#define FF_MESH_H

class FFvector;
class FFtwinEdge;

class FFmesh
{
public:
  char name[128];

  FFvector *fs;
  FFvector *es;
  FFvector *vs;
  FFvector *ns;
  FFvector *ms;
  FFvector *gs;
  
  int NumFaces;
  int NumHoles;
  int NumHandles;
  int NumComponents;
  
  FFtwinEdge* gate;
  
  FFmesh();
  FFmesh(char* n);
  ~FFmesh();

  void normalize();

  void computePerVertexNormals();
  void computePerFaceNormals();
};

#endif
